var Agent = require("../index")
var MessageDef = Agent.MessageDef
var EventEmitter = new (require("events").EventEmitter)()
var Assignment = null
Agent
.onAgentSuicide(function() {
	Assignment = null
	EventEmitter.emit("drop")
})
.on("JobDropAssignment",function(){
	console.log("Receive assignment drop!")
	Assignment = null
	EventEmitter.emit("drop")
})
.on("AskAssignment",function(message,responder){
	responder( new MessageDef.Reply( Assignment ))
})
.on("CrawlbackAssignment",function(message){
	Assignment  = message	
	EventEmitter.emit("assignment", {
		id : Assignment.id,
		date_start : Assignment.dateStart,
		date_end : Assignment.dateEnd,
		object : {
			stream_type : Assignment.streamType,
			social_media : Assignment.socialMedia,
			content : Assignment.content
		},
		token_list : Assignment.tokenList
	})
})
function onAssignmentReady( fn ) {
	EventEmitter.on("assignment", fn )
	return this
}
function onAssignmentDrop( fn ) {
	EventEmitter.on("drop", fn )
	return this
}
function sendSuccessResult( streamCount, extraInfo ) {
	extraInfo = extraInfo || {}
	var id = Assignment.id
	Assignment = null
	var message = new MessageDef.CrawlbackFinish(
		id,
		"success",
		streamCount,
		{},
		new Date().getTime()
	)
	Agent.tell( 
		Agent.getMasterIdentity(),
		message
	)
}

function sendErrorResult( err ) {
	var id = Assignment.id
	Assignment = null
	var message = new MessageDef.CrawlbackFinish(
		id,
		"error",
		0,
		{ error : err },
		new Date().getTime()
	)
	Agent.tell( 
		Agent.getMasterIdentity(),
		message
	)
}
Agent.onAssignmentDrop = onAssignmentDrop
Agent.onAssignmentReady = onAssignmentReady
Agent.sendErrorResult = sendErrorResult
Agent.sendSuccessResult = sendSuccessResult
module.exports = Agent