var underscore  = require("underscore")
var MessageDef = require("crawler-message-definition")
var Request = require("request")
var Url = require("url")
var ThrottleExec = require("throttle-exec")
var bluebird = require("bluebird")
var ThrottleInstance = new ThrottleExec(100)
var CurrentMetadata = {}

var Module = {}
var performRequest = ThrottleInstance.wrap(function(requestParam){
	return new Promise(function(resolve,reject){
		Request(requestParam,function(err,response,body){
			if(err){
				reject(err)
			} else {
				var statusCode = response.statusCode
				// console.log(response)
				if ( statusCode < 400 ) {
					var msg = MessageDef.unserialize(JSON.stringify(body))
					resolve(msg)
				} else {
					var errObj = new Error("Error on performing request")
					errObj.detail = body
					errObj.statusCode = statusCode
					reject(errObj)
				}
			}
		})
	})	
})


function requestFormatter(data,pattern){
	return {
		header : {
			ip_address : CurrentMetadata.ip_address,
			port : CurrentMetadata.port,
			social_media : CurrentMetadata.social_media,
			pattern : pattern
		},
		body : data.toString()
	}
}


function sendMessage(target,message,pattern){
	pattern = pattern || "tell"
	var url = Url.format({
		host : [target.ip_address,target.port].join(":"),
		protocol : "http"
	})
	var requestParameter = {
		url : url,
		json : requestFormatter(message,pattern),
		method : "POST"
	}
	return performRequest(requestParameter)
}

function tell(target,message) {
	return sendMessage(target,message,"tell")
}

function ask(target,message) {
	return sendMessage(target,message,"ask")
}

function main(metaData){
	var that = this
	CurrentMetadata = metaData
}
Module.init 	= main
Module.sendMessage = sendMessage
Module.tell 	= tell
Module.ask 	= ask
module.exports = Module